nitg: add option --global
[nit.git] / tests / tests.sh
index 84801a3..f470498 100755 (executable)
@@ -19,6 +19,7 @@
 
 # Set lang do default to avoid failed tests because of locale
 export LANG=C
+export NIT_TESTING=true
 
 usage()
 {
@@ -35,6 +36,35 @@ Usage: $e [options] modulenames
 END
 }
 
+# $1 is the pattern of the test
+# $2 is the file to compare to
+# the result is:
+#   0: if the file to compare to do not exists
+#   1: if the file match
+#   2: if the file match with soso
+#   3: if the file do not match
+function compare_to_result()
+{
+       local pattern="$1"
+       local sav="$2"
+       if [ ! -r "$sav" ]; then return 0; fi
+       diff -u "out/$pattern.res" "$sav" > "out/$pattern.diff.sav.log"
+       if [ "$?" == 0 ]; then
+               return 1
+       fi
+       [ -z "$soso" ] && return 3
+       sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
+       sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
+       grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
+       grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
+       diff -u "out/$pattern.res2" "out/$pattern.sav2" > "out/$pattern.diff.sav2.log"
+       if [ "$?" == 0 ]; then
+               return 2
+       else
+               return 3
+       fi
+}
+
 # As argument: the pattern used for the file
 function process_result()
 {
@@ -44,72 +74,56 @@ function process_result()
        description=$2
        SAV=""
        NSAV=""
-       FAIL=""
-       NFAIL=""
+       FIXME=""
+       NFIXME=""
        SOSO=""
        NSOSO=""
        SOSOF=""
        NSOSOF=""
        for sav in "sav/$engine/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
-               if [ -r "$sav" ]; then
-                       diff -u "out/$pattern.res" "$sav" > "out/$pattern.diff.sav.log"
-                       if [ "$?" == 0 ]; then
-                               SAV="$sav"
-                       else
-                               NSAV="$sav"
-                       fi
-                       [ -z "$soso" ] && continue
-                       sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
-                       sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
-                       grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
-                       grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
-                       diff -u "out/$pattern.res2" "out/$pattern.sav2" > "out/$pattern.diff.sav2.log"
-                       if [ "$?" == 0 ]; then
-                               SOSO="$sav"
-                       else
-                               NSOSO="$sav"
-                       fi
-               fi
+               compare_to_result "$pattern" "$sav"
+               case "$?" in
+                       0)
+                               ;; # no file
+                       1)
+                               SAV="$sav" ;;
+                       2)
+                               SOSO="$sav" ;;
+                       3)
+                               NSAV="$sav";;
+               esac
        done
        for sav in "sav/$engine/fixme/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.fail"; do
-               if [ -r "$sav" ]; then
-                       diff -u "out/$pattern.res" "$sav" > "out/$pattern.diff.fail.log"
-                       if [ "$?" == 0 ]; then
-                               FAIL="$sav"
-                       else
-                               NFAIL="$sav"
-                       fi
-                       [ -z "$soso" ] && continue
-                       sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
-                       sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.fail2"
-                       grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
-                       grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.fail2"
-                       diff -u "out/$pattern.res2" "out/$pattern.fail2" > "out/$pattern.diff.fail2.log"
-                       if [ "$?" == 0 ]; then
-                               SOSOF="$sav"
-                       else
-                               NSOSOF="$sav"
-                       fi
-               fi
+               compare_to_result "$pattern" "$sav"
+               case "$?" in
+                       0)
+                               ;; # no file
+                       1)
+                               FIXME="$sav" ;;
+                       2)
+                               SOSOF="$sav" ;;
+                       3)
+                               NFIXME="$sav";;
+               esac
        done
        grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
        NYI="$?"
        if [ -n "$SAV" ]; then
                if [ -n "$tap" ]; then
                        echo "ok - $description"
-               elif [ -z "$FAIL" ]; then
+               elif [ -z "$FIXME" ]; then
                        echo "[ok] out/$pattern.res $SAV"
                else
-                       echo "[ok] out/$pattern.res $SAV - but $FAIL remains!"
+                       echo "[ok] out/$pattern.res $SAV - but $FIXME remains!"
                fi
                ok="$ok $pattern"
-       elif [ -n "$FAIL" ]; then
+       elif [ -n "$FIXME" ]; then
                if [ -n "$tap" ]; then
                        echo "not ok - $description # TODO expected failure"
                else
-                       echo "[fail] out/$pattern.res $FAIL"
+                       echo "[fixme] out/$pattern.res $FIXME"
                fi
-               ok="$ok $pattern"
+               todos="$todos $pattern"
        elif [ -n "$SOSO" ]; then
                if [ -n "$tap" ]; then
                        echo "ok - $description # SOSO"
@@ -123,14 +137,14 @@ function process_result()
                else
                        echo "[todo] out/$pattern.res -> not yet implemented"
                fi
-               ok="$ok $pattern"
+               todos="$todos $pattern"
        elif [ -n "$SOSOF" ]; then
                if [ -n "$tap" ]; then
                        echo "not ok - $description # TODO SOSO expected failure"
                else
-                       echo "[fail soso] out/$pattern.res $SOSOF"
+                       echo "[fixme soso] out/$pattern.res $SOSOF"
                fi
-               ok="$ok $pattern"
+               todos="$todos $pattern"
        elif [ -n "$NSAV" ]; then
                if [ -n "$tap" ]; then
                        echo "not ok - $description"
@@ -139,11 +153,11 @@ function process_result()
                fi
                nok="$nok $pattern"
                echo "$ii" >> "$ERRLIST"
-       elif [ -n "$NFAIL" ]; then
+       elif [ -n "$NFIXME" ]; then
                if [ -n "$tap" ]; then
                        echo "not ok - $description"
                else
-                       echo "[======= changed out/$pattern.res $NFAIL ======]"
+                       echo "[======= changed out/$pattern.res $NFIXME ======]"
                fi
                nok="$nok $pattern"
                echo "$ii" >> "$ERRLIST"
@@ -160,7 +174,7 @@ function process_result()
 need_skip()
 {
        test "$noskip" = true && return 1
-       if grep "$engine" "sav/$1.skip" >/dev/null 2>&1 || echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
+       if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
                ((tapcount=tapcount+1))
                if [ -n "$tap" ]; then
                        echo "ok - $2 # skip"
@@ -215,11 +229,11 @@ done
 enginebinname=$engine
 case $engine in
        nitc) ;;
-       nitg) [ -z "$nososo" ] && soso=true ;;
-       nit) [ -z "$nososo" ] && soso=true
-               engine=niti ;;
-       niti) [ -z "$nososo" ] && soso=true
-               enginebinname=nit ;;
+       nitg) OPT="--global $OPT";;
+       nitg-s) enginebinname=nitg; OPT="--separate $OPT";;
+       nitg-e) enginebinname=nitg; OPT="--erasure $OPT";;
+       nit) engine=niti ;;
+       niti) enginebinname=nit ;;
 esac
 
 # The default nitc compiler
@@ -228,6 +242,13 @@ esac
 # Set NIT_DIR if needed
 [ -z "$NIT_DIR" ] && export NIT_DIR=..
 
+if sh -c "timelimit echo" 1>/dev/null 2>&1; then
+       TIMEOUT="timelimit -t 600"
+elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
+       TIMEOUT="timeout 600s"
+else
+       echo "No timelimit or timeout command detected. Tests may hang :("
+fi
 
 # Mark to distinguish files among tests
 # MARK=
@@ -252,6 +273,7 @@ fi
 
 ok=""
 nok=""
+todos=""
 
 # CLEAN the out directory
 rm -rf out/ 2>/dev/null
@@ -303,7 +325,7 @@ END
                                echo ""
                                echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes"
                        fi
-                       NIT_NO_STACK=1 $NITC --no-color $OPT -o "$ff.bin" "$i" $includes 2> "$ff.cmp.err" > "$ff.compile.log"
+                       NIT_NO_STACK=1 $TIMEOUT $NITC --no-color $OPT -o "$ff.bin" "$i" $includes 2> "$ff.cmp.err" > "$ff.compile.log"
                        ERR=$?
                        if [ "x$verbose" = "xtrue" ]; then
                                cat "$ff.compile.log"
@@ -315,7 +337,6 @@ END
                        cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
                        process_result $bf $bf
                elif [ -x "./$ff.bin" ]; then
-                       cp "$ff.cmp.err" "$ff.res"
                        test -z "$tap" && echo -n ". "
                        # Execute
                        args=""
@@ -323,7 +344,7 @@ END
                                echo ""
                                echo "NIT_NO_STACK=1 ./$ff.bin" $args
                        fi
-                       NIT_NO_STACK=1 "./$ff.bin" $args < "$inputs" >> "$ff.res" 2>"$ff.err"
+                       NIT_NO_STACK=1 $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
                        if [ "x$verbose" = "xtrue" ]; then
                                cat "$ff.res"
                                cat >&2 "$ff.err"
@@ -333,9 +354,8 @@ END
                        elif [ -d "$ff.write" ]; then
                                LANG=C /bin/ls -F $ff.write >> "$ff.res"
                        fi
-                       if [ -s "$ff.err" ]; then
-                               cat "$ff.err" >> "$ff.res"
-                       fi
+                       cp "$ff.res"  "$ff.res2"
+                       cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
                        process_result $bf $bf
 
                        if [ -f "$f.args" ]; then
@@ -346,17 +366,20 @@ END
                                        args="$line"
                                        bff=$bf"_args"$cptr
                                        fff=$ff"_args"$cptr
+                                       name="$bf args $cptr"
 
                                        # Sould we skip the input for this engine?
-                                       need_skip $bff "  args #$cptr" && continue
+                                       need_skip $bff "  $name" && continue
 
                                        rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
                                        if [ "x$verbose" = "xtrue" ]; then
                                                echo ""
                                                echo "NIT_NO_STACK=1 ./$ff.bin" $args
                                        fi
-                                       test -z "$tap" && echo -n "==> args #"$cptr " "
-                                       sh -c "NIT_NO_STACK=1 ./$ff.bin  ''$args < $inputs > $fff.res 2>$fff.err"
+                                       test -z "$tap" && echo -n "==> $name "
+                                       echo "./$ff.bin $args" > "./$fff.bin"
+                                       chmod +x "./$fff.bin"
+                                       sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $inputs > $fff.res 2>$fff.err"
                                        if [ "x$verbose" = "xtrue" ]; then
                                                cat "$fff.res"
                                                cat >&2 "$fff.err"
@@ -367,9 +390,10 @@ END
                                                LANG=C /bin/ls -F $fff.write >> "$fff.res"
                                        fi
                                        if [ -s "$fff.err" ]; then
-                                               cat "$fff.err" >> "$fff.res"
+                                               cp "$fff.res"  "$fff.res2"
+                                               cat "$fff.err" "$fff.res2" > "$fff.res"
                                        fi
-                                       process_result $bff "  args #$cptr"
+                                       process_result $bff "  $name"
                                done < $fargs
                        fi
                else
@@ -386,10 +410,11 @@ if [ -n "$tap" ]; then
        echo "# ok:" `echo $ok | wc -w`
        echo "# not ok:" `echo $nok | wc -w`
        echo "# no sav:" `echo $nos | wc -w`
+       echo "# todo/fixme:" `echo $todos | wc -w`
        exit
 fi
 
-echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos | wc -w`
+echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
 
 if [ -n "$nok" ]; then
        echo "fail: $nok"
@@ -398,6 +423,9 @@ fi
 if [ -n "$nos" ]; then
        echo "no sav: $nos"
 fi
+if [ -n "$todos" ]; then
+       echo "todo/fixme: $todos"
+fi
 
 # write $ERRLIST
 if [ "x$ERRLIST" != "x" ]; then